#
# denon.core - Denon/Marantz AV Receiver control core definitions
#
# Copyright 2012-2016 Perry The Cynic. All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#	http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#


#
# Parameters of the Denon AVR protocol
#
PORT = 23			# standard TCP port
VOL_ZERO = 80		# main volume encoding bias
VOL_DEFEAT = '99'	# special value for disabled, turned off, etc.
VOL_LOWEST = '995'	# minimum non-disabled (weird special case)

CHAN_ZERO = 50		# channel volume encoding bias


#
# Which zones to probe for
#
ZONE_CANDIDATES = ['2', '3', '4', '5', '6', '7', '8', '9']


#
# Canonical volume boundaries.
# These values are nominal dB (decibel) from reference.
# Note that several other volumes (channel trims, buck/boost, etc.)
# are separately measured relative to a base quantity (but also in dB).
#
VOLUME_REFERENCE = 0	# maximum rated output (or neutral)
VOLUME_DEFEAT = -81		# lowest dB value (effective off)


#
# NSE output status bits (other bits undefined)
#
NSE_PLAYABLE =	0x01
NSE_DIRECTORY =	0x02
NSE_CURRENT =	0x08
NSE_PICTURE =	0x40


#
# Internet preset codes are named C7 but are transmitted as integers.
# Each letter covers a row of eight slots
#
PRESET_ROW =	8


#
# Constants
#
SOURCE = 'SOURCE'	# share source with upstream (video, recording, etc.)
